`include "inc/queue.svh"

module queue (
    input clk,
    input[0:`PL-1] data_in,
    input shift_signal,
    output wire[0:`PL-1] data_out,
    output wire availability_signal
);

	reg[0:`PL-1] queue_buffers[0:`EN-1];

    wire[0:`EN+1] selector;
    assign selector[`EN] = shift_signal;
    assign selector[`EN+1] = data_in[0];

    assign availability_signal = !queue_buffers[`EN-1][0];

    assign data_out = queue_buffers[0];

    genvar j;
    generate
        for (j = 0; j < `EN; j = j + 1)
        begin : queue_selector_generator
            assign selector[j] = queue_buffers[j][0];
        end
    endgenerate

    initial
    begin
        int i;
        for (i = 0; i < `EN; i = i + 1) // initialize queue at 0
        begin
            queue_buffers[i] = 0;
        end
    end

    always @(posedge clk)
    begin
        
        
        casez (selector) // find queue entry

{0}

        endcase

    end

endmodule